// Global variables

	//Pilarnas tangentkoder. 
	int leftArrow = 37;
	int rightArrow = 39;
	int upArrow = 38;
	int downArrow = 40;
	int keyCode = 0; 
	int noKey=0;
	

	//Start position för Bolle. 
	double bolleXPos = 40; 
	double bolleYPos = 80; 
	double newBolleXPos=0;
	double newBolleYPos=0;
	double bolleYSpeed=0;

	double grundHastighet = 3; //Hastigheten. Kan ökas med jetPack för y.
	
	//Banan
	var obstaclesArray = [];  //
	var MAXY=160;		//Högsta position
	var MINY=0;
	var MINX=0;
	var MAXX=5000;		//Längd på banan
	
	//Hjälp att rita
	//Start position för banan, dvs vad är det som ritas ut på skärmen.
	double xPosLevel = 0;
		
	double drawScale=5;  //Antal pixlar per enhet. Sätts i Setup.
		
	var windowHeight;
	var windowWidth;
	var gameYPos;		//Banans undre position på skärmen
	var xMargin;		//Hur många enheter som minst kan vara mellan Bolle och sidan på skärmen
	var xSize;			//Antal enheter som visas på x-led (y-led är alltid 160)

	var coinArray = [];
    var spikeArray = [];
	//jetPacks
	var normals = 1/3;
	var Advanceds = 1.6/3;
	var snals = 0.8/3;
	var goldens = 2/3;
	var magickals = 2.3/3;
	var normalu = 2;
	var Advancedu = 2.2;
	var snalu = 1.2;
	var goldenu = 1.8;
	var magickalu = 1.75;
	var normalr = 1;
	var Advancedr = 1.2;
	var snalr = 1.5;
	var goldenr = 1.4;
	var magickalr = 1.7;
	//fuel and other stuff.
	var fuel = 100;
    var health = 30;
	var points = 0;
	// Setup the Processing Canvas
	
	
void setup()
{
	windowWidth=window.innerWidth*0.9;		//90% av fönstret använder vi till vår "Canvas"
	windowHeight=window.innerHeight*0.9;
	size(windowWidth, windowHeight);

	gameYPos = windowHeight*0.8;	//Understa 20% av Canvas reserveras för annat.
	drawScale=gameYPos/170;			//Totalt 170 enheter högt => drawscale = antal pixlar per enhet.
	xSize=windowWidth/drawScale;	//Spara undan hur många enheter man får i X-led.
	xMargin=xSize*0.2;				//När man är <20% från kanten så rullar bakgrunden
	
	strokeWeight( 10 );
	frameRate( 30 );
	
	//Skapa banan :
	createObstacles();
	createSpikes();
	createCoins();
	}


// Main draw loop
void draw()
{
	//-----------------//
	// Spellogik
	//-----------------//


	
	//Beräkna bolles önskade position
	double xLevelSpeed = grundHastighet;
	double yLevelSpeed = grundHastighet;

	newBolleXPos=bolleXPos;
	newBolleYPos=bolleYPos;
	
	bolleYSpeed=bolleYSpeed-0.1;  //Låt gravitationen öka hastigheten neråt.
	
	//Knapptryckningar
	if (keyCode == rightArrow) {
		newBolleXPos = bolleXPos + xLevelSpeed;
	} 
	if (keyCode == leftArrow) {
		newBolleXPos = bolleXPos - xLevelSpeed;
	}
	if ((keyCode == upArrow) && (fuel > -1)) {
		bolleYSpeed=bolleYSpeed+yLevelSpeed*0.3*normals;  //Låt jetpack skjuta på med en kraft som är 0.3 * yLevelSpeed.
	    //normals Advanceds snals goldens magickals
		fuel -= normalu;
	//normalu Advancedu snalu goldenu magickalu
	} 
	if (keyCode == downArrow) {
		bolleYSpeed=bolleYSpeed-yLevelSpeed*0.3;  //Köra jetpack neråt. Skall detta finnas? Eller skall man bara falla med gravitation?
	fuel += normalr;
	//normalr Advancedr snalr goldenr magickalr
	}

	newBolleYPos = bolleYPos + bolleYSpeed;		//Ny y position
	
	
	
	//Testa den önskade positionen

	var newBollePosXOK=true;
	var newBollePosYOK=true;
	
	//Stött på något hinder
	for (var obstacleIndex= 0; obstacleIndex < obstaclesArray.length; obstacleIndex++){
		if (isWithinCircle(newBolleXPos, newBolleYPos, 4, 
						obstaclesArray[obstacleIndex].xPos,obstaclesArray[obstacleIndex].yPos, obstaclesArray[obstacleIndex].height, 
						obstaclesArray[obstacleIndex].width)==true){
			if (isOnTop(bolleXPos, bolleYPos, 4, obstaclesArray[obstacleIndex].xPos,obstaclesArray[obstacleIndex].yPos, 
						obstaclesArray[obstacleIndex].height, obstaclesArray[obstacleIndex].width)==true){
				newBolleYPos=obstaclesArray[obstacleIndex].yPos+obstaclesArray[obstacleIndex].height+4;
				bolleYSpeed=0;
			} else {
				newBollePosXOK=false;
				newBollePosYOK=false;
				bolleYSpeed=0;	
			}
		} 
    }
	if (health < 0){
		newBollePosXOK=false;
		newBollePosYOK=false;
	}
	//Stött på någon spik?
	for (var spikeIndex= 0; spikeIndex < spikeArray.length; spikeIndex++)
	{
		if(distance2(bolleXPos,bolleYPos,spikeArray[spikeIndex].xPos,spikeArray[spikeIndex].yPos)<64)
		{
			health = health - spikeArray[spikeIndex].damage;
			//newBollePosXOK=false;
			//newBollePosYOK=false;
		}
	}
	//plockat upp en coin?
	
	for (var coinIndex= 0; coinIndex < coinArray.length; coinIndex++)
	{
		if(distance2(bolleXPos,bolleYPos,coinArray[coinIndex].xPos,coinArray[coinIndex].yPos)<64)
		{
			points = points + coinArray[coinIndex].value;
			coinArray[coinIndex].value = 0;
			//newBollePosXOK=false;
			//newBollePosYOK=false;
		}
	}
	//Utanför banan?
	if (newBolleYPos<MINY+4)  {
		bolleYSpeed=0;
		newBollePosYOK=false;
	}
	if (newBolleYPos>MAXY-4) {
		newBollePosYOK=false;
	}
	if ((newBolleXPos<MINX+4) || (newBolleXPos>MAXX-4)) {
		newBollePosXOK=false;
	}
	
	
	//Om nya positione var OK, hoppa till den
	if (newBollePosYOK==true) {
		bolleYPos=newBolleYPos;
	}
	if (newBollePosXOK==true) {
		bolleXPos=newBolleXPos;
	}
	
	//-----------------------//
	// Rita upp banan:
	//-----------------------//
	background(150,255,150);
	fill(70,165,70);
	rect(0,0,windowWidth,gameYPos+2);

	//Beräkna vad av banan som skall ritas ut, dvs sätta xPosLevel
	if (bolleXPos-xPosLevel<xMargin) {
		xPosLevel=bolleXPos-xMargin;
	}
	if (xPosLevel < 0) {
		xPosLevel = 0;
	}
	if (bolleXPos-xPosLevel>xSize-xMargin) {
		xPosLevel=bolleXPos+xMargin-xSize;
	}
	
	//Rita hinder
	fill(255,17,17);
	for (var obstacleIndex= 0; obstacleIndex < obstaclesArray.length; obstacleIndex++){
		rect(toX(obstaclesArray[obstacleIndex].xPos), toY(obstaclesArray[obstacleIndex].yPos+obstaclesArray[obstacleIndex].height),
			  obstaclesArray[obstacleIndex].width*drawScale, obstaclesArray[obstacleIndex].height*drawScale);
	}
   
	fill(155,157,17);
	
	for (var coinIndex= 0; coinIndex < coinArray.length; coinIndex++){
        if(coinArray[coinIndex].value > 0){
			ellipse(toX(coinArray[coinIndex].xPos), toY(coinArray[coinIndex].yPos),
			coinArray[coinIndex].r * drawScale * 2,coinArray[coinIndex].r * drawScale * 2);
	    }
	}
	
	fill(255,17,17);
	for (var spikeIndex= 0; spikeIndex < spikeArray.length; spikeIndex++){
        triangle(toX(spikeArray[spikeIndex].xPos-2.5), toY(spikeArray[spikeIndex].yPos - 3.75),
			     toX(spikeArray[spikeIndex].xPos+2.5), toY(spikeArray[spikeIndex].yPos - 3.75),
				 toX(spikeArray[spikeIndex].xPos+0), toY(spikeArray[spikeIndex].yPos + 4.5));	   
	}
	//-----------------------//
	// Rita Bolle:
	//-----------------------//
	
	fill(100,17,17);
	ellipse(toX(bolleXPos),toY(bolleYPos),8*drawScale,8*drawScale); 

	//--------------------------//
	//Rita status och debug
	//--------------------------//
    textSize(30);
	fill(0,0,0);
	
	//död?
	if (health<1)
	{
		textSize(gameYPos/2.5);
		text("game over", 5,gameYPos/2);
	} else{
		text(fuel + "fuel", 0, gameYPos+50);
		text(health + "health", 0, gameYPos+100);
	    text(points + "points", 0, gameYPos+150 )
		text("Collect all coins", windowWidth-350,gameYPos+50);
		text("Press DOWN to refuel", windowWidth-350,gameYPos+100);
	}
    //rik?
	if (points>4)
	{
		textSize(gameYPos/3.5);
		text("victory(not really...:)", 5,gameYPos/2);
	}
}

    //--------------------------//
	//Hjälpfunktioner:          //
	//--------------------------//


//Hjälpfunktion: Är punkten x,y inom rektangeln x0,y0,height,width?
function isWithin(x,y,x0,y0,height,width) {  
		if ((x0 <= x) &&  
		    (x0+width >= x) && 
			(y0 <= y) && 
			(y0+height >= y )){
			return true; 
		}else{
			return false;
	}
}

function distance2(xb,yb,x1,y1){
        return (x1-xb)*(x1-xb)+(y1-yb)*(y1-yb);


}
//Hjälpfunktion: Är någon del av cirkeln x,y,r inom rektangeln x0,y0,height,width?
function isWithinCircle(x,y,r,x0,y0,height,width) {
	var isWithinTest=false;

	isWithinTest=isWithin(x,y,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x+r,y,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x-r,y,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x,y+r,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x,y-r,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x+r*1,y+r*1,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x+r*1,y-r*1,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x-r*1,y+r*1,x0,y0,height,width);
	isWithinTest=isWithinTest || isWithin(x-r*1,y-r*1,x0,y0,height,width);
	
	return isWithinTest;
}

//Hjälpfunktion: Står cirkeln x,y,r på rektangeln x0,y0,height,width?
function isOnTop(x,y,r,x0,y0,height,width) {
	var isOnTopTest=false;

	isOnTopTest=isWithin(x,y,x0,y0,height,width);
	isOnTopTest=isOnTopTest || isWithin(x,y-1.1*r,x0,y0,height,width);

	isOnTopTest=isOnTopTest || isWithin(x-r,y-1.1*r,x0,y0,height,width);
	isOnTopTest=isOnTopTest || isWithin(x+r,y-1.1*r,x0,y0,height,width);
	
	return isOnTopTest;
}

//Hjälpfunktion: Översätt X koordinat i spelet till X koordinat på skärmen
function toX(x)
{
   return (x-xPosLevel)*drawScale;
}

//Hjälpfunktion: Översätt Y koordinat i spelet till Y koordinat på skärmen
function toY(y)
{
   return gameYPos - (y*drawScale);
}



//------------------------//
//Lyssna på tangentbordet:
//------------------------//
//Tangent tryckt:
document.addEventListener('keydown', function(event) {
   keyCode = event.keyCode;
});	

//Tangent släppt:
document.addEventListener('keyup', function(event) {
	   keyCode = noKey;
});	


//------------------------//
//Lyssna på mus:
//------------------------//

//Hjälpfunktion: Översätt x,y till upp/ner/höger/vänster
function touchToKey(x,y) {
	if (y<windowHeight/3) {
		keyCode=upArrow;
	} else {
		if (y>2*windowHeight/3) {
			keyCode=downArrow;
		} else {
			if (x<windowWidth/2) {
				keyCode = leftArrow;
			}
			if (x>windowWidth/2) {
				keyCode = rightArrow;
			}
		}
	}
}
//Släpper skärmen
document.addEventListener('touchend', function(event) {
   if (event.touches.length==0) {
		keyCode = noKey;							//Körs om det inte finns något finger kvar som trycker
	} else {
		var x=parseInt(event.touches[0].clientX);   //Körs om något finger fortfarande trycker
		var y=parseInt(event.touches[0].clientY);
		touchToKey(x,y);
	}
		
});	

//Trycker på skärmen
document.addEventListener('touchstart', function(event) {
	var x=parseInt(event.changedTouches[0].clientX);
	var y=parseInt(event.changedTouches[0].clientY);
	touchToKey(x,y);
});	
